#ifndef BOOKW_H
#define BOOKW_H

#include <stddef.h>
#include "setup.h"
#include "handle.h"

#ifdef __cplusplus
extern "C" 
{
#endif

    XLAPI     BookHandle XLAPIENTRY xlCreateBookCW();

    XLAPI            int XLAPIENTRY xlBookLoadW(BookHandle handle, const wchar_t* filename);
    XLAPI            int XLAPIENTRY xlBookSaveW(BookHandle handle, const wchar_t* filename);

    XLAPI    SheetHandle XLAPIENTRY xlBookAddSheetW(BookHandle handle, const wchar_t* name);
    XLAPI    SheetHandle XLAPIENTRY xlBookGetSheetW(BookHandle handle, unsigned short index);
    XLAPI            int XLAPIENTRY xlBookDelSheetW(BookHandle handle, unsigned short index);
    XLAPI unsigned short XLAPIENTRY xlBookSheetCountW(BookHandle handle);

    XLAPI   FormatHandle XLAPIENTRY xlBookAddFormatW(BookHandle handle, FormatHandle initFormat);
    XLAPI     FontHandle XLAPIENTRY xlBookAddFontW(BookHandle handle, FontHandle initFont);
    XLAPI       unsigned XLAPIENTRY xlBookAddCustomNumFormatW(BookHandle handle, const wchar_t* customNumFormat);
    XLAPI const wchar_t* XLAPIENTRY xlBookCustomNumFormatW(BookHandle handle, unsigned fmt);

    XLAPI         double XLAPIENTRY xlBookDatePackW(BookHandle handle, unsigned short year, unsigned short month, unsigned short day,
                                                                       unsigned short hour, unsigned short min, unsigned short sec);

    XLAPI            int XLAPIENTRY xlBookDateUnpackW(BookHandle handle, double value, unsigned short* year, unsigned short* month, unsigned short* day,
                                                                                       unsigned short* hour, unsigned short* min, unsigned short* sec);

    XLAPI unsigned short XLAPIENTRY xlBookActiveSheetW(BookHandle handle);
    XLAPI           void XLAPIENTRY xlBookSetActiveSheetW(BookHandle handle, unsigned short index);

    XLAPI            int XLAPIENTRY xlBookAddPictureW(BookHandle handle, const wchar_t* filename);

    XLAPI           void XLAPIENTRY xlBookSetKeyW(BookHandle handle, const wchar_t* name, const wchar_t* key);
    XLAPI           void XLAPIENTRY xlBookSetLocaleW(BookHandle handle, const char* locale);
    XLAPI    const char* XLAPIENTRY xlBookErrorMessageW(BookHandle handle);

    XLAPI           void XLAPIENTRY xlBookReleaseW(BookHandle handle);

#ifdef __cplusplus
}
#endif

#endif
